/**
 * @file
 * VuoList_VuoAudioInputDevice C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoAudioInputDevice_H
#define VuoList_VuoAudioInputDevice_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoAudioInputDevice VuoList_VuoAudioInputDevice
 * A list of @ref VuoAudioInputDevice elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoAudioInputDevice
 * A list of @ref VuoAudioInputDevice elements.
 */
#ifndef VuoList_VuoAudioInputDevice_TYPE_DEFINED
typedef void * VuoList_VuoAudioInputDevice;
#endif

/**
 * Creates a new list of @ref VuoAudioInputDevice elements.
 */
VuoList_VuoAudioInputDevice VuoListCreate_VuoAudioInputDevice(void);

/**
 * Returns the @ref VuoAudioInputDevice at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoAudioInputDevice VuoListGetValueAtIndex_VuoAudioInputDevice(const VuoList_VuoAudioInputDevice list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoAudioInputDevice(VuoList_VuoAudioInputDevice list, const VuoAudioInputDevice value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoAudioInputDevice(VuoList_VuoAudioInputDevice list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoAudioInputDevice(VuoList_VuoAudioInputDevice list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoAudioInputDevice(const VuoList_VuoAudioInputDevice list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoAudioInputDevice VuoList_VuoAudioInputDevice_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoAudioInputDevice_jsonFromValue(const VuoList_VuoAudioInputDevice value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoAudioInputDevice_summaryFromValue(const VuoList_VuoAudioInputDevice value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoAudioInputDevice VuoList_VuoAudioInputDevice_valueFromString(const char *str);
char * VuoList_VuoAudioInputDevice_stringFromValue(const VuoList_VuoAudioInputDevice value);
/// @}

/**
 * @}
 */

#endif
