/**
 * @file
 * VuoList_VuoAudioOutputDevice C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoAudioOutputDevice_H
#define VuoList_VuoAudioOutputDevice_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoAudioOutputDevice VuoList_VuoAudioOutputDevice
 * A list of @ref VuoAudioOutputDevice elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoAudioOutputDevice
 * A list of @ref VuoAudioOutputDevice elements.
 */
#ifndef VuoList_VuoAudioOutputDevice_TYPE_DEFINED
typedef void * VuoList_VuoAudioOutputDevice;
#endif

/**
 * Creates a new list of @ref VuoAudioOutputDevice elements.
 */
VuoList_VuoAudioOutputDevice VuoListCreate_VuoAudioOutputDevice(void);

/**
 * Returns the @ref VuoAudioOutputDevice at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoAudioOutputDevice VuoListGetValueAtIndex_VuoAudioOutputDevice(const VuoList_VuoAudioOutputDevice list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoAudioOutputDevice(VuoList_VuoAudioOutputDevice list, const VuoAudioOutputDevice value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoAudioOutputDevice(VuoList_VuoAudioOutputDevice list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoAudioOutputDevice(VuoList_VuoAudioOutputDevice list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoAudioOutputDevice(const VuoList_VuoAudioOutputDevice list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoAudioOutputDevice VuoList_VuoAudioOutputDevice_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoAudioOutputDevice_jsonFromValue(const VuoList_VuoAudioOutputDevice value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoAudioOutputDevice_summaryFromValue(const VuoList_VuoAudioOutputDevice value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoAudioOutputDevice VuoList_VuoAudioOutputDevice_valueFromString(const char *str);
char * VuoList_VuoAudioOutputDevice_stringFromValue(const VuoList_VuoAudioOutputDevice value);
/// @}

/**
 * @}
 */

#endif
